<?php
defined('BASEPATH') or exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/userguide3/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'auth';
$route['404_override'] = 'Custom404';
$route['translate_uri_dashes'] = FALSE;
$route['edit-karyawan/(:any)'] = 'kepegawaian/edit/$1';
$route['upate-karyawan/(:any)'] = 'kepegawaian/upload/$1';
$route['detail/(:any)'] = 'detail/karyawan/$1';
$route['detail/pribadi/(:num)'] = 'detail/pribadi/$1';
$route['alamat-tinggal/karyawan/(:num)'] = 'detail/alamatTinggal/$1';
$route['alamat-surat/karyawan/(:num)'] = 'detail/alamatSurat/$1';

$route['edit-alamat-tinggal/(:any)'] = 'detail/editAlamatTinggal/$1';
$route['alamat-surat/karyawan/edit/(:any)'] = 'detail/editAlamatSurat/$1';

$route['riwayat-kerja/karyawan/(:num)'] = 'detail/riwayat/$1';
$route['riwayat-kerja/karyawan/edit/(:num)'] = 'detail/riwayatEdit/$1';

$route['training/karyawan/(:num)'] = 'detail/training/$1';
$route['training/karyawan/edit/(:num)'] = 'detail/editTraining/$1';
$route['training-kerja/karyawan/destroy/(:num)/(:num)'] = 'detail/destroyTraining/$1/$2';

$route['keluarga/karyawan/(:num)'] = 'detail/keluarga/$1';
$route['keluarga-karyawan/updating/(:num)'] = 'detail/editKeluargaKaryawan/$1';
$route['anak-karyawan/(:any)'] = 'detail/anak/$1';
$route['detail/anak/edit/(:num)'] = 'detail/editAnak/$1';
$route['orangtua/karyawan/(:num)'] = 'detail/orangTua/$1';
$route['orangtua/karyawan/edit/(:num)'] = 'detail/editOrtu/$1';
$route['alamat-orangtua/(:any)'] = 'detail/AlamatOrangTua/$1';
$route['alamat-orangtua/edit/(:any)'] = 'detail/editAlamatOrangTua/$1';
$route['mertua/karyawan/(:num)'] = 'detail/mertua/$1';
$route['mertua-karyawan/store/(:num)'] = 'detail/mertua/$1';
$route['mertua-karyawan/karyawan/edit/(:num)'] = 'detail/editMertua/$1';
$route['alamat-mertua/(:any)'] = 'detail/AlamatMertua/$1';
$route['alamat-mertua/edit/(:any)'] = 'detail/editAlamatMertua/$1';

$route['pengalaman-kerja/karyawan/(:num)'] = '/detail/pengalaman/$1';
$route['pengalaman-kerja/karyawan/edit/(:num)'] = 'detail/editPengalaman/$1';
$route['pengalaman-kerja/karyawan/destroy/(:num)/(:num)'] = 'detail/destroyPengalaman/$1/$2';

$route['mutasi/(:any)'] = 'mutasi/karyawan/$1';
$route['promosi/(:any)'] = 'promosi/karyawan/$1';
$route['pengangkatan/(:any)'] = 'pengangkatan/karyawan/$1';
$route['resign/(:any)'] = 'resign/karyawan/$1';
$route['demosi/(:any)'] = 'demosi/karyawan/$1';

$route['foto-karyawan/(:num)'] = 'detail/foto/$1';
$route['karyawan-jabatan/(:num)'] = 'jabatanController/index/$1';

$route['department-data'] = 'jabatan/get_department_data';
$route['devisi-data'] = 'jabatan/get_devisi_data';
$route['level-data'] = 'jabatan/get_level_data';