<?php
class Auth extends CI_Controller
{
    //function ini sebagai kontruksi dari semua function di controller ini
    public function __construct()
    {
        parent::__construct();
        $this->load->model('auth_model');
    }

    //function index adalah halaman utama yang akan di tampilkan
    public function index()
    {
        //jika session "nama_pegawai" maka "level" dari session akan di pindahkan ke function lain. Jika tidak ada maka akan menampilkan login
        if ($this->session->userdata('nama_pegawai')) {
            redirect('cover');
        } else {
            $data['title'] = 'Login Pegawai';
            $this->load->view('template/header', $data);
            $this->load->view('login_view');
        }
    }


    public function do_login()
    {
        $nama_pegawai = $this->input->post('nama_pegawai');
        $password = $this->input->post('password');

        $user = $this->auth_model->get_user_by_auth($nama_pegawai, $password);

        if ($user) {
            $userData = array(
                'nama_pegawai' => $user->nama,
                'username' => $user->username,
                'id_pegawai' => $user->id_user,
                'id_karyawan' => $user->id_karyawan,
                'level' => $user->level
            );
            $this->session->set_userdata($userData);
            redirect('cover');
        } else {
            $this->session->set_flashdata('login_error', 'Login gagal. Periksa kembali nama pengguna dan password.');
            redirect('auth');
        }
    }


    public function logout()
    {
        $this->session->sess_destroy();
        redirect('auth');
    }
}
