<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Data_kepegawaian extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->model('Karyawan');
        $this->load->model('Agama');
        $this->load->model('Pendidikan_terakhir');
        $this->load->model('Jabatan');
        $this->load->model('Users');
        $this->load->helper('date');
    }

    public function index()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['title'] = 'List Karyawan';
            $data['karyawan'] = $this->Karyawan->getAllKaryawan();
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function mantan()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['title'] = 'List Mantan Karyawan';
            $data['karyawan'] = $this->Karyawan->getAllKaryawan();
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function users()
    {
        if ($this->session->userdata('nama_pegawai')) {
            if ($this->session->userdata('level') == 'Admin') {
                $data['title'] = 'List Users';
                $data['karyawan'] = $this->Users->getAllUsers();
                $this->load->view('layouts/template', $data);
            } else {
                redirect('cover');
            }
        } else {
            redirect('auth');
        }
    }

    public function ganti_password($id_user)
    {
        // Ambil data password baru dari form
        $new_password = $this->input->post('new_password');

        // Hash password baru sebelum disimpan ke database
        $hashed_password = password_hash($new_password, PASSWORD_DEFAULT);

        // Update kolom password untuk user yang bersangkutan
        $this->Users->updatePassword($id_user, $hashed_password);

        $nama = $pegawai->nama;
        $this->session->set_flashdata('add', "Password Pegawai $nama Berhasil Diubah");
        redirect('data_kepegawaian/users');
    }

    public function ganti_frid($id_user)
    {
        // Ambil data password baru dari form
        $new_frid = $this->input->post('new_frid');
        $new_password = $this->input->post('new_frid');

        // Hash password baru sebelum disimpan ke database
        $hashed_password = password_hash($new_password, PASSWORD_DEFAULT);

        // Update kolom password untuk user yang bersangkutan
        $this->Users->updateFRID($id_user, $new_frid);
        $this->Users->updatePassword($id_user, $hashed_password);

        $nama = $pegawai->nama;
        $this->session->set_flashdata('add', "FRID Pegawai $nama Berhasil Diubah");
        redirect('data_kepegawaian/users');
    }

    public function update_level($id)
    {
        // Lakukan verifikasi sesuai dengan kebutuhan, seperti cek level pengguna yang mengakses atau lainnya

        $newLevel = $this->input->post('level');

        // Update level pengguna
        $this->Users->updateLevel($id, $newLevel);

        // Set flashdata untuk notifikasi
        $this->session->set_flashdata('update_level', 'Level pengguna berhasil diperbarui.');

        // Redirect ke halaman daftar pengguna
        $nama = $pegawai->nama;
        $this->session->set_flashdata('add', "Level Pegawai $nama Berhasil Diubah");
        redirect('data_kepegawaian/users');
    }


    public function edit($karyawan)
    {
        $data['title'] = 'Edit karyawan';
        // $this->form_validation->set_rules('name', 'Username', 'required');
        $data['agama'] = $this->Agama->getAgamaAll();
        $data['title'] = 'Form | Karyawan';
        $data['pendidikan_terakhir'] = $this->Pendidikan_terakhir->getPenakhirAll();
        $data['jabatan'] = $this->Jabatan->getJabatanAll();
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);

        $data['karyawan']  = $this->Karyawan->detailKaryawan($karyawan);


        $this->form_validation->set_rules('name', 'nama lengkap', 'required');
        $this->form_validation->set_rules('tempat_lahir', 'tempat lahir ', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir ', 'required');
        $this->form_validation->set_rules('jenis_kelamin', 'jenis kelamin ', 'required');
        $this->form_validation->set_rules('gol_darah', 'golongan darah');
        $this->form_validation->set_rules('rhesus', 'rhesus');
        $this->form_validation->set_rules('no_ktp', 'nomor ktp', 'required');
        $this->form_validation->set_rules('no_kk', 'no_kk', 'required');
        $this->form_validation->set_rules('status_kawin', 'status perkawinan', 'required');
        $this->form_validation->set_rules('agama', 'agama', 'required');
        $this->form_validation->set_rules('kebangsaan', 'kebangsaan');
        $this->form_validation->set_rules('suku_bangsa', 'suku bangsa');
        $this->form_validation->set_rules('pendidikan_terakhir', 'pendidikan terakhir', 'required');
        $this->form_validation->set_rules('golongan', 'golongan');
        $this->form_validation->set_rules('pangkat', 'pangkat');
        $this->form_validation->set_rules('asal_sekolah', 'asal sekolah ', 'required');
        $this->form_validation->set_rules('jurusan', 'jurusan', 'required');
        $this->form_validation->set_rules('tahun_lulus', 'tahun lulus');
        $this->form_validation->set_rules('ukuran_kemeja', 'ukuran kemeja', 'required');
        $this->form_validation->set_rules('ukuran_sepatu', 'ukuran sepatu', 'required');
        $this->form_validation->set_rules('ukuran_celana', 'ukuran celana', 'required');

        if ($this->form_validation->run() === FALSE) {
            $this->load->view('layouts/template', $data);
        } else {
            $this->Karyawan->updating();
            $this->session->set_flashdata('success', 'Data Pegawai Berhasil Diubah');
            redirect('detail/' . $karyawan);
        }
    }

    public function jabatan()
    {
        if ($this->session->userdata('nama_pegawai')) {
            if ($this->session->userdata('level') == 'Admin') {
                $data['title'] = 'List Jabatan';
                $data['jabatan'] = $this->Jabatan->getJabatanAllList();
                $this->load->view('layouts/template', $data);
            } else {
                redirect('cover');
            }
        } else {
            redirect('auth');
        }
    }

    public function tambah_jabatan()
    {
        if ($this->session->userdata('nama_pegawai')) {
            if ($this->session->userdata('level') == 'Admin') {
                $data['title'] = 'Tambah Jabatan';
                $data['jabatan'] = $this->Jabatan->getJabatanAllList();
                $data['departments'] = $this->db->get('department')->result();
                $data['devisi'] = $this->db->get('devisi')->result();
                $data['levels'] = [
                    'President Director',
                    'Director',
                    'Manager',
                    'Vice Manager',
                    'Head of Division',
                    'Coordinator',
                    'Staff',
                ];

                $this->load->library('form_validation');

                $this->form_validation->set_rules('nama_jabatan', 'Nama Jabatan', 'required');
                $this->form_validation->set_rules('departement_id', 'Department', 'required|integer');
                $this->form_validation->set_rules('level', 'Level', 'required');
                $this->form_validation->set_rules('devisi_id', 'Devisi', 'required|integer');

                if ($this->form_validation->run() === FALSE) {
                    // Tampilkan form jika validasi gagal
                    $this->load->view('layouts/template', $data);
                } else {
                    // Siapkan data untuk dimasukkan ke database
                    $data = [
                        'nama_jabatan' => $this->input->post('nama_jabatan'),
                        'department_id' => $this->input->post('departement_id'),
                        'level' => $this->input->post('level'),
                        'devisi_id' => $this->input->post('devisi_id'),
                        'created_at' => date('Y-m-d H:i:s'),
                        'updated_at' => date('Y-m-d H:i:s'),
                    ];

                    // Simpan data ke database
                    $id = $this->Jabatan->tambah_jabatan($data);

                    if ($id) {
                        $this->session->set_flashdata('success', 'Data jabatan berhasil ditambahkan.');
                        redirect('data_kepegawaian/jabatan');
                    } else {
                        $this->session->set_flashdata('error', 'Terjadi kesalahan saat menyimpan data.');
                        $this->load->view('layouts/template', $data);
                    }
                }
            } else {
                redirect('cover');
            }
        } else {
            redirect('auth');
        }
    }
}