<?php

class detail extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('Karyawan');
        $this->load->model('Anak');
        $this->load->model('AlamatOrangTua');
        $this->load->model('AlamatMertua');
        $this->load->model('Tinggal');
        $this->load->model('Surat');
        $this->load->model('Pengalaman');
        $this->load->model('Riwayat');
        $this->load->model('Training');
        $this->load->model('Keluarga');
        $this->load->model('OrangTua');
        $this->load->model('Mertua');
        $this->load->model('Sejarah_perubahan');
    }

    public function pribadi($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
        $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
        $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
        $data['title'] = 'Detail Pribadi ';

        $this->load->view('layouts/template', $data);
    }
    
    public function karyawan($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
        $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
        $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
        $data['title'] = 'Detail karyawan ';

        $this->load->view('layouts/template', $data);
    }

    public function anak($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama_anak', 'Nama lengkap anak', 'required');
        $this->form_validation->set_rules('tgl_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenkel', 'jenis kelamin', 'required');
        $this->form_validation->set_rules('pendidikan', 'pendidikan');
        $this->form_validation->set_rules('status_kerja', 'status_kerja', 'required');
        $this->form_validation->set_rules('status_menikah', 'status_menikah', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data anak yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            $this->Anak->upload();
            $this->session->set_flashdata('success', 'Data Anak Berhasil di tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function AlamatOrangTua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'Alamat', 'required');
        $this->form_validation->set_rules('kelurahan', 'Kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'Kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('kode_post', 'Kode post', 'required');
        $this->form_validation->set_rules('telp_rumah', 'telp. rumah');
        $this->form_validation->set_rules('handphone', 'Handphone');
        $this->form_validation->set_rules('telp_emergency', 'telp_emergency');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data anak yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->AlamatOrangTua->create();
            $this->session->set_flashdata('success', 'Data Alamat Orang Tua Berhasil di tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function editKeluargaKaryawan($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama perusahaan', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal_lahir', 'required');
        $this->form_validation->set_rules('pekerjaan', 'pekerjaan', 'required');
        $this->form_validation->set_rules('perusahaan', 'perusahaan');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data keluarga yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Keluarga->updating($karyawan);
            $this->session->set_flashdata('success', 'Data Keluarga Berhasil di ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function editAlamatOrangTua($karyawan)
    {
        // die('update');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'Alamat', 'required');
        $this->form_validation->set_rules('kelurahan', 'Kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'Kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('kode_post', 'Kode post', 'required');
        $this->form_validation->set_rules('telp_rumah', 'telp. rumah');
        $this->form_validation->set_rules('handphone', 'Handphone');
        $this->form_validation->set_rules('telp_emergency', 'telp_emergency');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data anak yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->AlamatOrangTua->updates();
            $this->session->set_flashdata('success', 'Data Alamat Orang Tua Berhasil di ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function AlamatMertua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'Alamat', 'required');
        $this->form_validation->set_rules('kelurahan', 'Kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'Kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('kode_post', 'Kode post', 'required');
        $this->form_validation->set_rules('telp_rumah', 'telp. rumah');
        $this->form_validation->set_rules('handphone', 'Handphone');
        $this->form_validation->set_rules('telp_emergency', 'telp_emergency');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, alamat tinggal mertua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->AlamatMertua->creating();
            $this->session->set_flashdata('success', 'Alamat Tinggal Mertua Berhasil Di Tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }
    public function editAlamatMertua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'Alamat', 'required');
        $this->form_validation->set_rules('kelurahan', 'Kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'Kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('kode_post', 'Kode post', 'required');
        $this->form_validation->set_rules('telp_rumah', 'telp. rumah');
        $this->form_validation->set_rules('handphone', 'Handphone');
        $this->form_validation->set_rules('telp_emergency', 'telp_emergency');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, alamat tinggal mertua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->AlamatMertua->editing();
            $this->session->set_flashdata('success', 'Alamat Tinggal Mertua Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    // alamat tinggal
    public function alamatTinggal($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'alamat tinggal', 'required');
        $this->form_validation->set_rules('rt/rw', 'Rt / Rw', 'required');
        $this->form_validation->set_rules('kelurahan', 'kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'kota', 'required');
        $this->form_validation->set_rules('kode_post', 'kode post', 'required|numeric');
        $this->form_validation->set_rules('telp_rumah', 'telp. Rumah');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('hp(CDMA)', 'HP (CDMA)');
        $this->form_validation->set_rules('hp(GSM)', 'HP (GSM)', 'required');
        $this->form_validation->set_rules('telp_emergency', 'telp. Emergency ');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, alamat tinggal yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            $this->Tinggal->store();
            $this->session->set_flashdata('success', 'Alamat Tinggal Berhasil Di Tambahkan');
            redirect(base_url('/detail/' . $karyawan));
        }
    }

    public function editAlamatTinggal($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'alamat tinggal', 'required');
        $this->form_validation->set_rules('rt/rw', 'Rt / Rw', 'required');
        $this->form_validation->set_rules('kelurahan', 'kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'kota', 'required');
        $this->form_validation->set_rules('kode_post', 'kode post', 'required|numeric');
        $this->form_validation->set_rules('telp_rumah', 'telp. Rumah');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('hp(GSM)', 'HP (GSM)', 'required');
        $this->form_validation->set_rules('hp(CDMA)', 'HP (CDMA)');
        $this->form_validation->set_rules('telp_emergency', 'telp. Emergency ');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, alamat tinggal yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            $this->Tinggal->updates();
            $this->session->set_flashdata('success', 'Alamat Tinggal Berhasil Di Ubah');
            redirect(base_url('/detail/' . $karyawan));
        }
    }

    // alamat surat
    public function alamatSurat($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'alamat surat', 'required');
        $this->form_validation->set_rules('rt/rw', 'Rt / Rw', 'required');
        $this->form_validation->set_rules('kelurahan', 'kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'kota', 'required');
        $this->form_validation->set_rules('kode_post', 'kode post', 'required|numeric');
        $this->form_validation->set_rules('telp_rumah', 'telp. Rumah');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('hp(GSM)', 'HP (GSM)', 'required');
        $this->form_validation->set_rules('hp(CDMA)', 'HP (CDMA)');
        $this->form_validation->set_rules('telp_emergency', 'telp. Emergency ');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Alamat surat yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            $this->Surat->store();
            $this->session->set_flashdata('success', 'Alamat Surat Berhasil Di Tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }
    public function editAlamatSurat($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('alamat', 'alamat surat', 'required');
        $this->form_validation->set_rules('rt/rw', 'Rt / Rw', 'required');
        $this->form_validation->set_rules('kelurahan', 'kelurahan', 'required');
        $this->form_validation->set_rules('kecamatan', 'kecamatan', 'required');
        $this->form_validation->set_rules('kota', 'kota', 'required');
        $this->form_validation->set_rules('kode_post', 'kode post', 'required|numeric');
        $this->form_validation->set_rules('telp_rumah', 'telp. Rumah');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('hp(GSM)', 'HP (GSM)', 'required');
        $this->form_validation->set_rules('hp(CDMA)', 'HP (CDMA)');
        $this->form_validation->set_rules('telp_emergency', 'telp. Emergency ');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, alamat surat yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            $this->Surat->edit();
            $this->session->set_flashdata('success', 'Alamat Surat Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    // TODO : Create pengalaman kerja
    public function pengalaman($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama_perusahaan', 'Nama perusahaan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('tahun', 'Tahun', 'required');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Penagalaman kerja yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Pengalaman->store();
            $this->session->set_flashdata('success', 'Pengalaman Kerja Berhasil Di Tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function destroyPengalaman($pengalaman, $karyawan)
    {
        // var_dump($karyawan);

        $this->Pengalaman->destroy($pengalaman, $karyawan);
    }



    // TODO : create riwayat pekrjaan 
    public function riwayat($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);


        $this->form_validation->set_rules('tanggal_masuk', 'tanggal masuk', 'required');
        // $this->form_validation->set_rules('tanggal_keluar', 'tanggal keluar', 'required');
        $this->form_validation->set_rules('jabatan_masuk', 'jabatan masuk', 'required');
        $this->form_validation->set_rules('jabatan_akhir', 'jabatan akhir', 'required');
        $this->form_validation->set_rules('perusahaan', 'perusahaan', 'required');


        if ($this->form_validation->run() === FALSE) {
            // die('ok');
            $this->load->view('layouts/header', $data);
            $this->load->view('kepegawaian/detail', $data);
            $this->load->view('modal/modal', $data);
            $this->load->view('layouts/footer');
        } else {
            // echo 'ok';
            $this->Riwayat->store();
            $this->session->set_flashdata('success', 'Ditambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    // TODO : create training 
    // *;
    public function training($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('training', 'Nama Training', 'required');
        $this->form_validation->set_rules('kota/tempat', 'Kota/tempat', 'required');
        $this->form_validation->set_rules('tahun', 'Tahun', 'required');


        if ($this->form_validation->run() === FALSE) {
            // die('ok');
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';

            $this->session->set_flashdata('error', 'Mohon maaf, data trainig yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Training->store();
            $this->session->set_flashdata('success', 'Data Training Berhasil Ditambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }
    // TODO : edit training 
    // *;
    public function editTraining($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('training', 'Nama Training', 'required');
        $this->form_validation->set_rules('kota/tempat', 'Kota/tempat', 'required');
        $this->form_validation->set_rules('tahun', 'Tahun', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';

            $this->session->set_flashdata('error', 'Mohon maaf, data training yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Training->ubah();
            $this->session->set_flashdata('success', 'Data Training Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function destroyTraining($training, $karyawan)
    {
        // var_dump($karyawan);

        $this->Training->destroy($training, $karyawan);
    }
    // TODO : CREATE KELUARGA KECIL 
    // *
    public function keluarga($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama suami/istri', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'Tanggal lahir', 'required');
        $this->form_validation->set_rules('pekerjaan', 'pekerjaan', 'required');
        $this->form_validation->set_rules('perusahaan', 'Perusahaan');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';

            $this->session->set_flashdata('error', 'Mohon maaf, data keluarga yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Keluarga->store();
            $this->session->set_flashdata('success', 'Data Keluarga kecil Berhasil Ditambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    // TODO : CREATE DATA ORANG TUA 
    // * 

    public function orangTua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenis_kelamin', 'Jenis kelamin', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');


        if ($this->form_validation->run() === FALSE) {
            // die('ok');
            $this->session->set_flashdata('error', 'Mohon maaf, data orang tua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->OrangTua->store();
            $this->session->set_flashdata('success', 'Data Orang Tua Berhasil Ditambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }
    // TODO : CREATE DATA MERTUA
    // * 
    public function mertua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenis_kelamin', 'Jenis kelamin', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data mertua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Mertua->store();
            $this->session->set_flashdata('success', 'Data Mertua Berhasil Di Tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function NIK($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nik', 'NIK', 'required');
        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, NIK yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Karyawan->NIK($karyawan);
            $this->session->set_flashdata('success', 'NIK Berhasil Di Tambahkan');
            redirect(base_url('detail/' . $karyawan));
        }
    }


    public function editPengalaman($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $this->form_validation->set_rules('nama_perusahaan', 'Nama perusahaan', 'required');
        $this->form_validation->set_rules('kota', 'Kota', 'required');
        $this->form_validation->set_rules('tahun', 'Tahun', 'required');

        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Pengalaman kerja yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Pengalaman->change();
            $this->session->set_flashdata('success', 'Data Pengalaman Kerja Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function editAnak($karyawan)
    {
        // die('edit');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);


        $this->form_validation->set_rules('nama_anak', 'Nama lengkap anak', 'required');
        $this->form_validation->set_rules('tgl_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenkel', 'jenis kelamin', 'required');
        $this->form_validation->set_rules('pendidikan', 'pendidikan');
        $this->form_validation->set_rules('status_kerja', 'status_kerja', 'required');
        $this->form_validation->set_rules('status_menikah', 'status_menikah', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data orang tua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Anak->edites();
            $this->session->set_flashdata('success', 'Data Anak Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function editOrtu($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenis_kelamin', 'Jenis kelamin', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, data orang tua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->OrangTua->change();
            $this->session->set_flashdata('success', 'Data Orang Tua Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function editMertua($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

        $this->form_validation->set_rules('nama', 'Nama', 'required');
        $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir', 'required');
        $this->form_validation->set_rules('jenis_kelamin', 'Jenis kelamin', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');


        if ($this->form_validation->run() === FALSE) {
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Data mertua yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        } else {
            // echo 'ok';
            $this->Mertua->update();
            $this->session->set_flashdata('success', 'Data Mertua Berhasil Di Ubah');
            redirect(base_url('detail/' . $karyawan));
        }
    }

    public function foto($karyawan)
    {
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');
    
        $config['upload_path'] = FCPATH . 'upload/avatar/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'Profil_' . $karyawan . '_' . $nama;
    
        $this->load->library('upload', $config);
        $this->upload->initialize($config);
    
        if ($this->upload->do_upload('avatar')) {
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];
    
            // Salin file ke folder kedua
            $source = FCPATH . 'upload/avatar/' . $file_name;
            $destination = FCPATH . '../presensi/assets/img/profil/' . $file_name;
    
            // Cek dan hapus file jika sudah ada
            if (file_exists($destination)) {
                unlink($destination); // Hapus file yang sudah ada
            }
    
            if (!copy($source, $destination)) {
                // Handle error jika gagal menyalin file
                $error = error_get_last();
                log_message('error', 'Failed to copy file from ' . $source . ' to ' . $destination . ': ' . $error['message']);
                $this->session->set_flashdata('error', 'Foto berhasil diunggah, tetapi gagal menyalin ke folder kedua.');
                redirect(base_url('/detail/' . $karyawan));
                return;
            }
    
            // Panggil fungsi updateFoto dari model
            $this->Karyawan->updateFoto($karyawan, $file_name);
    
            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto Profil yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }

    public function upload_ktp($karyawan)
    {
        // die('foto');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');

        $config['upload_path'] = FCPATH . '/upload/ktp/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'KTP_' . $karyawan . '_' . $nama;

        $this->load->library('upload', $config);
        $this->upload->initialize($config);

        if ($this->upload->do_upload('foto_ktp')) {
            // die('success');
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];

            $this->Karyawan->updateFotoKTP($karyawan, $file_name); // Panggil fungsi updateFoto dari model dengan satu parameter

            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto KTP yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }

    public function upload_bpjs_kesehatan($karyawan)
    {
        // die('foto');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');

        $config['upload_path'] = FCPATH . '/upload/bpjs_kesehatan/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'bpjs_kesehatan_' . $karyawan . '_' . $nama;

        $this->load->library('upload', $config);
        $this->upload->initialize($config);

        if ($this->upload->do_upload('foto_bpjs_kesehatan')) {
            // die('success');
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];

            $this->Karyawan->updateFotoBPJSKesehatan($karyawan, $file_name); // Panggil fungsi updateFoto dari model dengan satu parameter

            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto BPJS Kesehatan yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }

    public function upload_bpjs_ketenagakerjaan($karyawan)
    {
        // die('foto');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');

        $config['upload_path'] = FCPATH . '/upload/bpjs_ketenagakerjaan/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'bpjs_ketenagakerjaan_' . $karyawan . '_' . $nama;

        $this->load->library('upload', $config);
        $this->upload->initialize($config);

        if ($this->upload->do_upload('foto_bpjs_ketenagakerjaan')) {
            // die('success');
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];

            $this->Karyawan->updateFotoBPJSKetenagakerjaan($karyawan, $file_name); // Panggil fungsi updateFoto dari model dengan satu parameter

            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto BPJS Ketenagakerjaan yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }

    public function upload_npwp($karyawan)
    {
        // die('foto');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');

        $config['upload_path'] = FCPATH . '/upload/npwp/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'NPWP_' . $karyawan . '_' . $nama;

        $this->load->library('upload', $config);
        $this->upload->initialize($config);

        if ($this->upload->do_upload('foto_npwp')) {
            // die('success');
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];

            $this->Karyawan->updateFotoNPWP($karyawan, $file_name); // Panggil fungsi updateFoto dari model dengan satu parameter

            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto NPWP yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }

    public function upload_kk($karyawan)
    {
        // die('foto');
        $timeZone = 'Asia/Jakarta';
        $now = new DateTime('now', new DateTimeZone($timeZone));
        $timestamp = $now->getTimestamp();
        $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
        $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
        $nama = $this->input->post('nama');

        $config['upload_path'] = FCPATH . '/upload/kk/'; // Direktori untuk menyimpan gambar
        $config['allowed_types'] = 'jpg|jpeg|png|gif'; // Jenis file yang diizinkan
        $config['file_name'] = 'KK_' . $karyawan . '_' . $nama;

        $this->load->library('upload', $config);
        $this->upload->initialize($config);

        if ($this->upload->do_upload('foto_kk')) {
            // die('success');
            // Jika gambar berhasil diupload, simpan data gambar ke database
            $upload_data = $this->upload->data();
            $file_name = $upload_data['file_name'];

            $this->Karyawan->updateFotoKK($karyawan, $file_name); // Panggil fungsi updateFoto dari model dengan satu parameter

            // Redirect ke halaman sukses atau halaman lain yang sesuai
            redirect(base_url('/detail/' . $karyawan));
        } else {
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan);
            $data['sejarah'] = $this->Sejarah_perubahan->get_pegawai_history($karyawan);
            $data['sejarah_terbaru'] = $this->Sejarah_perubahan->get_pegawai_latest_history($karyawan);
            $data['title'] = 'Detail karyawan ';
            $this->session->set_flashdata('error', 'Mohon maaf, Foto KK yang tercatat tidak valid. Mohon isikan dengan benar. Terima kasih.');
            $this->load->view('layouts/template', $data);
        }
    }
}
