<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Dikeluarkan extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->library('session');
        $this->load->model('Karyawan');
        $this->load->model('Agama');
        $this->load->model('Pendidikan_terakhir');
        $this->load->model('Jabatan');
        $this->load->helper('date');
        $this->load->model('Kepegawaian_model');
    }

    public function index()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['title'] = 'List Karyawan';
            $data['karyawan'] = $this->Karyawan->getAllKaryawan();
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function sp1($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['title'] = 'SP1 Pegawai';
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function sp2($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['title'] = 'SP2 Pegawai';
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function dikeluarkan($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['title'] = 'Dikeluarkan Pegawai';
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function sp1_sistem($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $pegawai = $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

            if (!$pegawai) {
                // Tampilkan pesan jika ID pegawai tidak valid atau redirect sesuai kebutuhan
            } else {
                // Tangani form promosi
                if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                    $status_dikeluarkan = '1';
                    $sk = $this->input->post('sk');
                    $tmt = $this->input->post('tmt');

                    // Validasi data sesuai kebutuhan

                    // Perbarui status karyawan di tabel kepegawaian
                    $this->Karyawan->update_status_dikeluarkan($karyawan, $status_dikeluarkan);

                    // Tambahkan riwayat promosi ke tabel 'riwayat_promosi'
                    $this->Kepegawaian_model->tambah_riwayat_sp1($karyawan, $sk, $tmt);

                    $this->session->set_flashdata('success', 'Pemberian SP 1 karyawan berhasil.');

                    redirect('dikeluarkan');
                }
            }
        } else {
            redirect('auth');
        }
    }

    public function sp2_sistem($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $pegawai = $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

            if (!$pegawai) {
                // Tampilkan pesan jika ID pegawai tidak valid atau redirect sesuai kebutuhan
            } else {
                // Tangani form promosi
                if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                    $status_dikeluarkan = '2';
                    $sk = $this->input->post('sk');
                    $tmt = $this->input->post('tmt');

                    // Validasi data sesuai kebutuhan

                    // Perbarui status karyawan di tabel kepegawaian
                    $this->Karyawan->update_status_dikeluarkan($karyawan, $status_dikeluarkan);

                    // Tambahkan riwayat promosi ke tabel 'riwayat_promosi'
                    $this->Kepegawaian_model->tambah_riwayat_sp2($karyawan, $sk, $tmt);

                    $this->session->set_flashdata('success', 'Pemberian SP 2 karyawan berhasil.');

                    redirect('dikeluarkan');
                }
            }
        } else {
            redirect('auth');
        }
    }

    public function dikeluarkan_sistem($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $pegawai = $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);

            if (!$pegawai) {
                // Tampilkan pesan jika ID pegawai tidak valid atau redirect sesuai kebutuhan
            } else {
                // Tangani form promosi
                if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                    $status_dikeluarkan = '3';
                    $sk = $this->input->post('sk');
                    $tmt = $this->input->post('tmt');

                    // Validasi data sesuai kebutuhan

                    // Perbarui status karyawan di tabel kepegawaian
                    $this->Karyawan->update_status_dikeluarkan_karyawan($karyawan, $status_dikeluarkan);

                    // Tambahkan riwayat promosi ke tabel 'riwayat_promosi'
                    $this->Kepegawaian_model->tambah_riwayat_dikeluarkan($karyawan, $sk, $tmt);

                    $this->session->set_flashdata('success', 'Karyawan berhasil dikeluarkan.');

                    redirect('dikeluarkan');
                }
            }
        } else {
            redirect('auth');
        }
    }
}
