<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Form extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->model('Karyawan');
        $this->load->model('Agama');
        $this->load->model('Pendidikan_terakhir');
        $this->load->model('Jabatan');
        $this->load->helper('date');
    }

    public function index()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['agama'] = $this->Agama->getAgamaAll();
            $data['title'] = 'Form';
            $data['pendidikan_terakhir'] = $this->Pendidikan_terakhir->getPenakhirAll();
            $data['jabatan'] = $this->Jabatan->getJabatanAll();
            $timeZone = 'Asia/Jakarta';
            $now = new DateTime('now', new DateTimeZone($timeZone));
            $timestamp = $now->getTimestamp();
            $data['created_at'] = date('Y-m-d H:i:s', $timestamp);
            $data['updated_at'] = date('Y-m-d H:i:s', $timestamp);
            $this->form_validation->set_rules('name', 'nama lengkap', 'required');
            $this->form_validation->set_rules('tempat_lahir', 'tempat lahir ', 'required');
            $this->form_validation->set_rules('tanggal_lahir', 'tanggal lahir ', 'required');
            $this->form_validation->set_rules('jenis_kelamin', 'jenis kelamin ', 'required');
            $this->form_validation->set_rules('gol_darah', 'golongan darah');
            $this->form_validation->set_rules('rhesus', 'rhesus');
            $this->form_validation->set_rules('no_ktp', 'nomor ktp ', 'required|numeric');
            $this->form_validation->set_rules('no_kk', 'nomor kk ', 'required|numeric');
            $this->form_validation->set_rules('status_kawin', 'status perkawinan', 'required');
            $this->form_validation->set_rules('agama', 'agama', 'required');
            $this->form_validation->set_rules('kebangsaan', 'kebangsaan');
            $this->form_validation->set_rules('suku_bangsa', 'suku bangsa');
            $this->form_validation->set_rules('pendidikan_terakhir', 'pendidikan terakhir', 'required');
            $this->form_validation->set_rules('golongan', 'golongan');
            $this->form_validation->set_rules('pangkat', 'pangkat');
            $this->form_validation->set_rules('jabatan', 'jabatan', 'required');
            $this->form_validation->set_rules('status', 'status saat ini', 'required');
            $this->form_validation->set_rules('asal_sekolah', 'asal sekolah ', 'required');
            $this->form_validation->set_rules('jurusan', 'jurusan', 'required');
            $this->form_validation->set_rules('tahun_lulus', 'tahun lulus');
            $this->form_validation->set_rules('ukuran_kemeja', 'ukuran kemeja', 'required');
            $this->form_validation->set_rules('ukuran_sepatu', 'ukuran sepatu', 'required');
            $this->form_validation->set_rules('ukuran_celana', 'ukuran celana', 'required');
            $this->form_validation->set_rules('username', 'username', 'required');
            $this->form_validation->set_rules('password', 'password', 'required');

            if ($this->form_validation->run() === FALSE) {
                $this->load->view('layouts/template', $data);
            } else {
                $this->Karyawan->store();
                $id_karyawan = $this->db->insert_id(); // Mengambil ID baru saja dimasukkan
                $this->Karyawan->storeuser($id_karyawan); // Menggunakan ID karyawan untuk menyimpan data pengguna
                $this->session->set_flashdata('add', 'Pegawai Berhasil Di Tambahkan');
                redirect(base_url('data_kepegawaian'));
            }
        } else {
            redirect('auth');
        }
    }
}