<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Mutasi extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->library('session');
        $this->load->model('Karyawan');
        $this->load->model('Agama');
        $this->load->model('Pendidikan_terakhir');
        $this->load->model('Jabatan');
        $this->load->helper('date');
        $this->load->model('Kepegawaian_model');
    }
    public function index()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['title'] = 'List Karyawan';
            $data['karyawan'] = $this->Karyawan->getAllKaryawan();
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function karyawan($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $data['jabatan'] = $this->Jabatan->getJabatanAllList(); // Ambil data jabatan
            $data['pegawai'] = $this->Karyawan->detailKaryawan($karyawan); // Detail karyawan
            $data['title'] = 'Mutasi Pegawai';
            $this->load->view('layouts/template', $data); // Kirim data ke view
        } else {
            redirect('auth'); // Redirect ke halaman login jika session tidak valid
        }
    }



    public function mutasi_sistem($karyawan)
    {
        $pegawai = $this->Karyawan->detailKaryawan($karyawan);

        if (!$pegawai) {
            // Tampilkan pesan jika ID pegawai tidak valid atau redirect sesuai kebutuhan
        } else {
            // Tangani form promosi
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $divisi_awal = $pegawai['jabatan_id']; // Mengambil divisi awal dari hasil query
                $divisi_baru = $this->input->post('divisi');
                $sk = $this->input->post('sk');
                $tmt = $this->input->post('tmt');

                // Validasi data sesuai kebutuhan

                // Perbarui status karyawan di tabel kepegawaian
                $this->Karyawan->update_divisi($karyawan, $divisi_baru);

                // Tambahkan riwayat promosi ke tabel 'riwayat_promosi'
                $this->Kepegawaian_model->tambah_riwayat_mutasi($karyawan, $divisi_awal, $divisi_baru, $sk, $tmt);

                $this->session->set_flashdata('success', 'Mutasi karyawan berhasil.');

                redirect('mutasi');
            }
        }
    }
}