<?php
class Pengangkatan extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->library('session');
        $this->load->model('Karyawan');
        $this->load->model('Agama');
        $this->load->model('Pendidikan_terakhir');
        $this->load->model('Jabatan');
        $this->load->helper('date');
        $this->load->model('Kepegawaian_model');
    }
    public function index()
    {
        if ($this->session->userdata('nama_pegawai')) {
            $data['title'] = 'List Karyawan';
            $data['karyawan'] = $this->Karyawan->getAllKaryawan();
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function karyawan($karyawan)
    {
        if ($this->session->userdata('nama_pegawai')) {
            $this->load->model('kepegawaian_model');
            $data['pegawai'] =  $this->Karyawan->detailKaryawan($karyawan);
            $data['title'] = 'Pengangkatan Pegawai';
            $this->load->view('layouts/template', $data);
        } else {
            redirect('auth');
        }
    }

    public function proses_angkat_status_kerja($karyawan, $status)
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $sk = $this->input->post('sk');
            $tmt = $this->input->post('tmt');
    
            // Validasi data sesuai kebutuhan
    
            // Set nilai default untuk $status_baru
            $status_baru = '';
    
            // Periksa nilai $status dan atur $status_baru sesuai kondisi
            if ($status == 'Training') {
                $status_baru = 'Kontrak';
            } elseif ($status == 'Kontrak') {
                $status_baru = 'Tetap';
            }
    
            // Perbarui status karyawan di tabel kepegawaian jika $status_baru tidak kosong
            if (!empty($status_baru)) {
                $this->Karyawan->update_status_kerja($karyawan, $status_baru);
    
                // Tambahkan riwayat promosi ke tabel 'riwayat_promosi' hanya jika $status_baru bukan 'Training'
                if ($status_baru != 'Training') {
                    $this->Kepegawaian_model->tambah_riwayat_pengangkatan($karyawan, $sk, $tmt, $status, $status_baru);
                }
    
                $this->session->set_flashdata('success', 'Pengangkatan karyawan berhasil.');
    
                redirect('pengangkatan');
            } else {

            }
        }
    }

}
