<?php

class Karyawan extends CI_Model
{

    public function getAllKaryawan()
    {
        $this->db->select('karyawan.*, agama.nama_agama, pendidikan_terakhir.nama_pendidikan, jabatan.*');
        $this->db->from('karyawan');
        $this->db->join('agama', 'karyawan.agama_id = agama.id_agama');
        $this->db->join('jabatan', 'karyawan.jabatan_id = jabatan.id_jabatan');
        $this->db->join('pendidikan_terakhir', 'karyawan.pendidikan_terakhir_id = pendidikan_terakhir.id_pendidikan_terakhir');
        return $this->db->get()->result_array();
    }

    // detail

    public function getKaryawanByjabatan($jabatan)
    {
        $this->db->from('karyawan');
        $this->db->where('jabatan_id', $jabatan);
        $query = $this->db->get();

        return $query->result_array();
    }

    public function detailKaryawan($id)
    {
        $this->db->select('karyawan.*, agama.*, pendidikan_terakhir.nama_pendidikan, jabatan.nama_jabatan, alamat_tinggal.*, alamat_surat.*, pengalaman_kerja.*, riwayat_kerja.*, training.*, keluarga.*, orang_tua.*, mertua.*,');
        $this->db->from('karyawan');
        $this->db->join('agama', 'karyawan.agama_id = agama.id_agama');
        $this->db->join('jabatan', 'karyawan.jabatan_id = jabatan.id_jabatan');
        $this->db->join('pendidikan_terakhir', 'karyawan.pendidikan_terakhir_id = pendidikan_terakhir.id_pendidikan_terakhir');
        $this->db->join('alamat_tinggal', 'karyawan.id = alamat_tinggal.karyawan_id', 'left');
        $this->db->join('alamat_surat', 'karyawan.id = alamat_surat.karyawan_id', 'left');
        $this->db->join('pengalaman_kerja', 'karyawan.id = pengalaman_kerja.karyawan_id', 'left');
        $this->db->join('riwayat_kerja', 'karyawan.id = riwayat_kerja.karyawan_id', 'left');
        $this->db->join('training', 'karyawan.id = training.karyawan_id', 'left');
        $this->db->join('keluarga', 'karyawan.id = keluarga.karyawan_id', 'left');
        $this->db->join('orang_tua', 'karyawan.id = orang_tua.karyawan_id', 'left');
        $this->db->join('mertua', 'karyawan.id = mertua.karyawan_id', 'left');
        $this->db->where('karyawan.id', $id);
        $result = $this->db->get()->row_array();
        return $result;
    }
    // return $this->db->where('nama_karyawan', $name)->get('karyawan')->row_array();
    public function getPengalamanKerja($karyawanId)
    {
        // Ambil semua pengalaman kerja berdasarkan ID karyawan
        $this->db->where('karyawan_id', $karyawanId);
        $query = $this->db->get('pengalaman_kerja');
        return $query->result_array();
    }
    public function getTraining($karyawan)
    {
        $this->db->where('karyawan_id', $karyawan);
        $query = $this->db->get('training');
        return $query->result_array();
    }

    public function getRiwayat($karyawan)
    {
        $this->db->where('karyawan_id', $karyawan);
        $query = $this->db->get('riwayat_kerja');
        return $query->result_array();
    }

    public function Orangtua($karyawan)
    {
        $this->db->where('karyawan_id', $karyawan);
        $query = $this->db->get('orang_tua');
        return $query->result_array();
    }

    public function Mertua($karyawan)
    {
        $this->db->where('karyawan_id', $karyawan);
        $query = $this->db->get('mertua');
        return $query->result_array();
    }

    public function getAnakKaryawan($karyawan)
    {
        $this->db->select('anak.*');
        $this->db->from('anak');
        $this->db->join('keluarga', 'anak.keluarga_id = keluarga.id_keluarga');
        $this->db->where('keluarga.karyawan_id', $karyawan);
        $query = $this->db->get()->result_array();
        return $query;
    }

    public function getAlamatOrangTua($karyawan)
    {
        $this->db->select('alamat_orang_tua.*');
        $this->db->from('alamat_orang_tua');
        $this->db->join('orang_tua', 'alamat_orang_tua.orang_tua_id = orang_tua.id_orang_tua');
        $this->db->where('orang_tua.karyawan_id', $karyawan);
        $query = $this->db->get()->row_array();
        return $query;
    }

    public function getAlamatMertua($karyawan)
    {
        $this->db->select('alamat_mertua.*');
        $this->db->from('alamat_mertua');
        $this->db->join('mertua', 'alamat_mertua.mertua_id = mertua.id_mertua');
        $this->db->where('mertua.karyawan_id', $karyawan);
        $query = $this->db->get()->row_array();
        return $query;
    }



    // create
    public function store()
    {
        $kebangsaan = $this->input->post('kebangsaan');
        $negara = $this->input->post('negara'); // Pastikan 'negara' hanya muncul jika 'kebangsaan' adalah 'WNA'
        $bangsa = ($kebangsaan === 'WNI') ? 'WNI' : $negara;

        $data = [
            "nik" => $this->input->post('nik', true),
            'nama' => $this->input->post('name', true),
            'tempat_lahir' => $this->input->post('tempat_lahir', true),
            'tanggal_lahir' => $this->input->post('tanggal_lahir', true),
            'jenis_kelamin' => $this->input->post('jenis_kelamin', true),
            'gol_darah' => $this->input->post('gol_darah', true),
            'rhesus' => $this->input->post('rhesus', true),
            'suku_bangsa' => $this->input->post('suku_bangsa', true),
            'no_ktp' => $this->input->post('no_ktp', true),
            'no_kk' => $this->input->post('no_kk', true),
            'status_kawin' => $this->input->post('status_kawin', true),
            'agama_id' => $this->input->post('agama', true),
            'kebangsaan' => $bangsa,
            'pendidikan_terakhir_id' => $this->input->post('pendidikan_terakhir', true),
            'golongan' => $this->input->post('golongan', true),
            'pangkat' => $this->input->post('pangkat', true),
            'jabatan_id' => $this->input->post('jabatan', true),
            'tanggal_masuk' => $this->input->post('tanggal_masuk', true),
            'status' => $this->input->post('status', true),
            'asal_sekolah' => $this->input->post('asal_sekolah', true),
            'jurusan' => $this->input->post('jurusan', true),
            'tahun_lulus' => $this->input->post('tahun_lulus', true),
            'no_BPJS_ketenagakerjaan' => $this->input->post('no_BPJS_ketenagakerjaan', true),
            'no_BPJS_kesehatan' => $this->input->post('no_BPJS_kesehatan', true),
            'no_NPWP' => $this->input->post('no_NPWP', true),
            'ukuran_kemeja' => $this->input->post('ukuran_kemeja', true),
            'ukuran_sepatu' => $this->input->post('ukuran_sepatu', true),
            'ukuran_celana' => $this->input->post('ukuran_celana', true),
            'created_at_karyawan' => $this->input->post('created_at', true),
            'updated_at' => $this->input->post('updated_at', true),
        ];

        if (empty($data['gol_darah'])) {
            $data['gol_darah'] = '-';
        }
        if (empty($data['rhesus'])) {
            $data['rhesus'] = '-';
        }
        $this->db->insert('karyawan', $data);
    }

    public function storeuser($id_karyawan)
    {
        // Ambil data dari input
        $nik = $this->input->post('nik', true);
        $name = $this->input->post('name', true);
        $jabatan_id = $this->input->post('jabatan', true);
        $username = $this->input->post('username', true);
        $password = password_hash($this->input->post('password', true), PASSWORD_BCRYPT); // Hash NIK menggunakan bcrypt untuk password
        $kode = $this->input->post('password', true);
        $level = 'Karyawan';

        // Tentukan department berdasarkan id_jabatan
        if ($jabatan_id == 1) {
            $department = 1;
        } elseif ($jabatan_id == 2 || ($jabatan_id >= 3 && $jabatan_id <= 12) || ($jabatan_id >= 29 && $jabatan_id <= 30)) {
            $department = 2;
        } elseif (($jabatan_id >= 13 && $jabatan_id <= 17) || ($jabatan_id >= 18 && $jabatan_id <= 22) || ($jabatan_id >= 23 && $jabatan_id <= 28) || $jabatan_id == 32) {
            $department = 3;
        } else {
            // Default department jika tidak ada kondisi yang cocok
            $department = 0;
        }

        // Persiapkan data untuk dimasukkan ke dalam database
        $data = [
            "nik" => $nik,
            'id_karyawan' => $id_karyawan,
            'nama' => $name,
            'jabatan_id' => $jabatan_id,
            'department_id' => $department,
            'username' => $username,
            'password' => $password,
            'kode' => $kode,
            'level' => $level,
        ];

        // Simpan data ke dalam database
        // (Kode penyimpanan ke dalam database belum ditulis dalam contoh ini)

        // Lakukan pengecekan jika insert gagal
        if (!$this->db->insert('users', $data)) {
            return false; // Atau berikan pesan kesalahan khusus
        }

        return true;
    }


    // edit
    public function updating()
    {
        $kebangsaan = $this->input->post('kebangsaan');
        $negara = $this->input->post('negara'); // Pastikan 'negara' hanya muncul jika 'kebangsaan' adalah 'WNA'
        $bangsa = ($kebangsaan === 'WNI') ? 'WNI' : $negara;

        $data = [
            "nik" => $this->input->post('nik', true),
            'nama' => $this->input->post('name', true),
            'tempat_lahir' => $this->input->post('tempat_lahir', true),
            'tanggal_lahir' => $this->input->post('tanggal_lahir', true),
            'jenis_kelamin' => $this->input->post('jenis_kelamin', true),
            'gol_darah' => $this->input->post('gol_darah', true),
            'rhesus' => $this->input->post('rhesus', true),
            'suku_bangsa' => $this->input->post('suku_bangsa', true),
            'no_ktp' => $this->input->post('no_ktp', true),
            'no_kk' => $this->input->post('no_kk', true),
            'status_kawin' => $this->input->post('status_kawin', true),
            'agama_id' => $this->input->post('agama', true),
            'kebangsaan' => $bangsa,
            'pendidikan_terakhir_id' => $this->input->post('pendidikan_terakhir', true),
            'golongan' => $this->input->post('golongan', true),
            'pangkat' => $this->input->post('pangkat', true),
            'tanggal_masuk' => $this->input->post('tanggal_masuk', true),
            'asal_sekolah' => $this->input->post('asal_sekolah', true),
            'jurusan' => $this->input->post('jurusan', true),
            'tahun_lulus' => $this->input->post('tahun_lulus', true),
            'no_BPJS_ketenagakerjaan' => $this->input->post('no_BPJS_ketenagakerjaan', true),
            'no_BPJS_kesehatan' => $this->input->post('no_BPJS_kesehatan', true),
            'no_NPWP' => $this->input->post('no_NPWP', true),
            'ukuran_kemeja' => $this->input->post('ukuran_kemeja', true),
            'ukuran_sepatu' => $this->input->post('ukuran_sepatu', true),
            'ukuran_celana' => $this->input->post('ukuran_celana', true),
            'created_at_karyawan' => $this->input->post('created_at', true),
            'updated_at' => $this->input->post('updated_at', true),
        ];
        $this->db->where('id', $this->input->post('karyawan'));
        $this->db->update('karyawan', $data);
    }

    public function NIK($karyawan)
    {
        $data = [
            'nik' => $this->input->post('nik', TRUE),
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function updateFoto($karyawan, $file_name)
    {
        // Data yang akan diupdate
        $data = [
            'foto_karyawan' => $file_name,
        ];

        // Update tabel karyawan
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);

        // Data yang akan diupdate pada tabel users
        $userData = [
            'foto' => $file_name,
        ];

        // Update tabel users
        $this->db->where('id_karyawan', $karyawan);
        $this->db->update('users', $userData);
    }

    public function updateFotoKTP($karyawan, $file_name)
    {
        $data = [
            'foto_ktp_karyawan' => $file_name,
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function updateFotoKK($karyawan, $file_name)
    {
        $data = [
            'foto_kk_karyawan' => $file_name,
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function updateFotoBPJSKesehatan($karyawan, $file_name)
    {
        $data = [
            'foto_bpjs_kesehatan_karyawan' => $file_name,
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function updateFotoBPJSKetenagakerjaan($karyawan, $file_name)
    {
        $data = [
            'foto_bpjs_ketenagakerjaan_karyawan' => $file_name,
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function updateFotoNPWP($karyawan, $file_name)
    {
        $data = [
            'foto_npwp_karyawan' => $file_name,
        ];
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function update_divisi($karyawan, $divisi_baru)
    {
        // Ambil department_id berdasarkan jabatan_id (divisi_baru) dari tabel jabatan
        $this->db->select('department_id'); // Pilih kolom department_id
        $this->db->where('id_jabatan', $divisi_baru); // Cari berdasarkan id_jabatan
        $query = $this->db->get('jabatan'); // Nama tabel jabatan
        $jabatan = $query->row(); // Ambil satu baris data

        // Pastikan data department_id ditemukan
        if ($jabatan && isset($jabatan->department_id)) {
            $department = $jabatan->department_id; // Ambil nilai department_id
        } else {
            $department = 0; // Default jika tidak ditemukan
        }

        // Update tabel karyawan
        $data_karyawan = array('jabatan_id' => $divisi_baru);
        $this->db->where('id', $karyawan); // Sesuaikan dengan kolom ID di tabel karyawan
        $this->db->update('karyawan', $data_karyawan);

        // Update tabel users
        $data_users = array(
            'jabatan_id' => $divisi_baru,
            'department_id' => $department
        );
        $this->db->where('id_karyawan', $karyawan); // Sesuaikan dengan kolom yang sesuai di tabel users
        $this->db->update('users', $data_users);
    }


    public function update_promosi($karyawan, $status_baru)
    {
        $data = array('jabatan_id' => $status_baru);
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function update_status_dikeluarkan($karyawan, $status_dikeluarkan)
    {
        $data = array(
            'status_dikeluarkan' => $status_dikeluarkan,
        );
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function update_status_dikeluarkan_karyawan($karyawan, $status_dikeluarkan)
    {
        $data = array(
            'status' => 'diberhentikan',
            'status_dikeluarkan' => $status_dikeluarkan,
        );
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }

    public function update_status_kerja($karyawan, $status_kerja)
    {
        $data = array(
            'status' => $status_kerja,
        );
        $this->db->where('id', $karyawan);
        $this->db->update('karyawan', $data);
    }
}