<?php

class Sejarah_perubahan extends CI_Model
{
    public function get_pegawai_history($karyawan)
    {
        $this->db->select('jenis_perubahan, tmt, sk, from, to');
        $this->db->from('sejarah_perubahan');
        $this->db->where('id_pegawai', $karyawan);
        $query = $this->db->get();
        $result = $query->result_array();

        foreach ($result as &$perubahan) {
            // Cek jika nilai "from" adalah nomor
            if (is_numeric($perubahan['from'])) {
                // Ambil nama jabatan dari tabel "jabatan"
                $this->db->select('nama_jabatan');
                $this->db->from('jabatan');
                $this->db->where('id_jabatan', $perubahan['from']);
                $jabatan_from = $this->db->get()->row('nama_jabatan');
                // Ganti nilai "from" dengan nama jabatan
                $perubahan['from'] = $jabatan_from;
            }

            // Cek jika nilai "to" adalah nomor
            if (is_numeric($perubahan['to'])) {
                // Ambil nama jabatan dari tabel "jabatan"
                $this->db->select('nama_jabatan');
                $this->db->from('jabatan');
                $this->db->where('id_jabatan', $perubahan['to']);
                $jabatan_to = $this->db->get()->row('nama_jabatan');
                // Ganti nilai "to" dengan nama jabatan
                $perubahan['to'] = $jabatan_to;
            }
        }

        return $result;
    }

    public function get_pegawai_latest_history($id_pegawai)
    {
        $this->db->select('jenis_perubahan, tmt, sk, from, to');
        $this->db->from('sejarah_perubahan');
        $this->db->where('id_pegawai', $id_pegawai);
        $this->db->order_by('tmt', 'desc'); // Mengurutkan berdasarkan tanggal secara menurun (descending)
        $this->db->limit(1); // Batasi hasil hanya satu baris
        $query = $this->db->get();
        $result = $query->row_array();

        // Ganti nilai "from" dengan nama jabatan
        if (is_numeric($result['from'])) {
            // Ambil nama jabatan dari tabel "jabatan"
            $this->db->select('nama_jabatan');
            $this->db->from('jabatan');
            $this->db->where('id_jabatan', $result['from']);
            $jabatan_from = $this->db->get()->row('nama_jabatan');
            // Ganti nilai "from" dengan nama jabatan
            $result['from'] = $jabatan_from;
        }

        // Ganti nilai "to" dengan nama jabatan
        if (is_numeric($result['to'])) {
            // Ambil nama jabatan dari tabel "jabatan"
            $this->db->select('nama_jabatan');
            $this->db->from('jabatan');
            $this->db->where('id_jabatan', $result['to']);
            $jabatan_to = $this->db->get()->row('nama_jabatan');
            // Ganti nilai "to" dengan nama jabatan
            $result['to'] = $jabatan_to;
        }

        return $result;
    }
}