<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tambah Jabatan</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/js/bootstrap.bundle.min.js"></script>
</head>

<body>
    <div class="container mt-5">
        <h3>Form Tambah Jabatan</h3>
        <form method="post" action="<?= site_url('data_kepegawaian/tambah_jabatan'); ?>">
            <!-- Nama Jabatan -->
            <div class="form-floating mb-3">
                <input type="text" class="form-control" id="floatingInput" placeholder=" " name="nama_jabatan">
                <label for="floatingInput">Nama Jabatan <span class="text-danger">*</span></label>
            </div>

            <!-- Departemen -->
            <div class="input-group mb-3">
                <input type="text" class="form-control" id="departement_id" placeholder="Masukkan ID Departemen"
                    aria-label="Departemen" aria-describedby="department-addon" name="departement_id">
                <span class="input-group-text" id="department-addon" data-bs-toggle="modal"
                    data-bs-target="#departmentModal">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                        class="bi bi-plus" viewBox="0 0 16 16">
                        <path
                            d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4" />
                    </svg>
                </span>
            </div>

            <!-- Devisi -->
            <div class="input-group mb-3">
                <input type="text" class="form-control" id="devisi_id" placeholder="Masukkan ID Devisi"
                    aria-label="Devisi" aria-describedby="devisi-addon" name="devisi_id">
                <span class="input-group-text" id="devisi-addon" data-bs-toggle="modal" data-bs-target="#devisiModal">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                        class="bi bi-plus" viewBox="0 0 16 16">
                        <path
                            d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4" />
                    </svg>
                </span>
            </div>

            <!-- Level -->
            <div class="input-group mb-3">
                <input type="text" class="form-control" id="level" placeholder="Masukkan Level" aria-label="Level"
                    aria-describedby="level-addon" name="level">
                <span class="input-group-text" id="level-addon" data-bs-toggle="modal" data-bs-target="#levelModal">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                        class="bi bi-plus" viewBox="0 0 16 16">
                        <path
                            d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4" />
                    </svg>
                </span>
            </div>

            <button type="submit" class="btn btn-primary">Simpan</button>
        </form>

        <!-- Modal Department -->
        <div class="modal fade" id="departmentModal" tabindex="-1" aria-labelledby="departmentModalLabel"
            aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="departmentModalLabel">Department Info</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <table class="table table-striped" id="departmentTable">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Nama Department</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($departments as $department): ?>
                                <tr data-id="<?= $department->id_department; ?>"
                                    data-name="<?= $department->nama_departmen; ?>">
                                    <td><?= $department->id_department; ?></td>
                                    <td><?= $department->nama_departmen; ?></td>
                                </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <!-- Modal Devisi -->
        <div class="modal fade" id="devisiModal" tabindex="-1" aria-labelledby="devisiModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="devisiModalLabel">Devisi Info</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <table class="table table-striped" id="devisiTable">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Nama Devisi</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($devisi as $dev): ?>
                                <tr data-id="<?= $dev->id_devisi; ?>" data-name="<?= $dev->nama_devisi; ?>">
                                    <td><?= $dev->id_devisi; ?></td>
                                    <td><?= $dev->nama_devisi; ?></td>
                                </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <!-- Modal Level -->
        <div class="modal fade" id="levelModal" tabindex="-1" aria-labelledby="levelModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="levelModalLabel">Level Info</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <table class="table table-striped" id="levelTable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Nama Level</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($levels as $index => $level): ?>
                                <tr data-name="<?= $level; ?>">
                                    <td><?= $index + 1; ?></td>
                                    <td><?= $level; ?></td>
                                </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>
    // Handle row click for Department
    $('#departmentTable').on('click', 'tr', function() {
        const id = $(this).data('id');
        $('#departement_id').val(id);
        $('#departmentModal').modal('hide');
    });

    // Handle row click for Devisi
    $('#devisiTable').on('click', 'tr', function() {
        const id = $(this).data('id');
        $('#devisi_id').val(id);
        $('#devisiModal').modal('hide');
    });

    // Handle row click for Level
    $('#levelTable').on('click', 'tr', function() {
        const name = $(this).data('name');
        $('#level').val(name);
        $('#levelModal').modal('hide');
    });
    // Handle row click for Department
    $('#departmentTable').on('click', 'tr', function() {
        const id = $(this).data('id');
        $('#departement_id').val(id);
        $('#departmentModal').modal('hide');
        forceCloseModal('#departmentModal');
    });

    // Handle row click for Devisi
    $('#devisiTable').on('click', 'tr', function() {
        const id = $(this).data('id');
        $('#devisi_id').val(id);
        $('#devisiModal').modal('hide');
        forceCloseModal('#devisiModal');
    });

    // Handle row click for Level
    $('#levelTable').on('click', 'tr', function() {
        const name = $(this).data('name');
        $('#level').val(name);
        $('#levelModal').modal('hide');
        forceCloseModal('#levelModal');
    });

    // Forcefully close modal and remove the backdrop
    function forceCloseModal(modalId) {
        $(modalId).on('hidden.bs.modal', function() {
            $('.modal-backdrop').remove();
        }).modal('hide');
    }
    </script>
</body>

</html>